'=========================   ==================================
'   1.0
'Y.D.E. 2013

$regfile = "m8def.dat"                                      ' 
$crystal = 11059200                                         ' 
$hwstack = 16
$swstack = 64
$framesize = 32
$baud = 9600

'*******************************************************************************
'*********************     ***********************

Nokia_spi_data Alias Portd.6 : Config Portd.6 = Output      'MOSI       -    
Nokia_spi_clock Alias Portd.5 : Config Portd.5 = Output     'SCK        -    
Nokia_cs Alias Portd.7 : Config Portd.7 = Output            'CS         -    
Display_reset Alias Portb.0 : Config Portb.0 = Output       'LCD_RESET  -    

Display_reset = 1
Nokia_cs = 1

Declare Sub Nokia_init()
Declare Sub Nokia_clear()
Declare Sub Nokia_text(byval Nokia_x As Byte , Byval Nokia_y As Byte , Byval Nokia_text As String , Byval Nokia_inversion As Byte)
Declare Sub Nokia_picture(bylabel Nokia_label As Word)

Dim W As Iram Word At 8 Overlay
Dim Nokia_data_9 As Integer

Dim S As String * 16                                        '   UART
'     
Dim Ss(8) As String * 16                                    ' 
'      
Dim J As Byte
Dim I As Byte
Dim Flagbuf As Bit

Call Nokia_init()                                           '  

'*******************************************************************************
'     
Config Pinb.5 = Input                                       '   
Config Pinb.4 = Input                                       '   
Config Pinb.3 = Input                                       '   
Config Pinb.2 = Input                                       '   

Portb.5 = 1
Portb.4 = 1
Portb.3 = 1
Portb.2 = 1

Key_a Alias Pinb.5
Key_b Alias Pinb.4
Key_c Alias Pinb.3
Key_d Alias Pinb.2                                          '  

Config Portc.3 = Output                                     '   
Config Portc.2 = Output                                     '   

Led_t Alias Portc.3                                         ' 
Led_r Alias Portc.2                                         ' 

Led_t = 0
Led_r = 0

Call Nokia_clear()                                          ' 
Nokia_data_9 = 159                                          '     128..159
Gosub Nokia_out_cmd

Call Nokia_text(1 , 2 , " Terminal  V1.0 " , 0)             ' :
Call Nokia_text(1 , 4 , "   $Baud=9600" , 0)                '  -   1...16,   1..8
Call Nokia_text(1 , 6 , "   Y.D.E.2013" , 0)                ' : 0- , 1-

Wait 3
 Call Nokia_clear()                                         ' 
Enable Interrupts                                           ' 
S = "...."
Flagbuf = 1
'**************************       
Do
 If Key_d = 0 Then                                          '    
    Led_r = 1
    Led_t = 1
    Call Nokia_clear()
    For I = 1 To 8
     Ss(i) = ""
    Next I
    I = 0
    Led_t = 0                                               ' 
    Led_r = 0
 End If
 If Key_a = 0 Then                                          '       UART
    Led_t = 1
    Printbin 97 : Printbin 13
    Waitms 300
    S = "-->a"
    Flagbuf = 1
    Led_t = 0
 End If
 If Key_b = 0 Then                                          '     b  UART
    Led_t = 1
    Printbin 98 : Printbin 13
    Waitms 300
    S = "-->b"
    Flagbuf = 1
    Led_t = 0
 End If
 If Key_c = 0 Then                                          '     c  UART
    Led_t = 1
    Printbin 99 : Printbin 13
    Waitms 300
    S = "-->c"
    Flagbuf = 1
    Led_t = 0
 End If
 If Ischarwaiting() = 1 Then                                '   UART
   J = Inkey()                                              '       <LF> ,  
   If J <> 10 Then
   Led_r = 1
    $timeout = 1000000
    Input S Noecho
    If J <> 10 Then S = Chr(j) + S
    Flagbuf = 1
    Led_r = 0
   End If
 End If
 If Flagbuf = 1 Then                                        '     
  Call Nokia_clear()                                        ' 
   Incr I
   If I < 9 Then Ss(i) = S                                  ' 
   If I > 8 Then                                            '      
    Ss(1) = Ss(2)
    Ss(2) = Ss(3)
    Ss(3) = Ss(4)
    Ss(4) = Ss(5)
    Ss(5) = Ss(6)
    Ss(6) = Ss(7)
    Ss(7) = Ss(8)
    Ss(8) = S
    I = 9                                                   ' i    ,   9  
   End If
   Call Nokia_text(1 , 1 , Ss(1) , 0)
   Call Nokia_text(1 , 2 , Ss(2) , 0)
   Call Nokia_text(1 , 3 , Ss(3) , 0)
   Call Nokia_text(1 , 4 , Ss(4) , 0)
   Call Nokia_text(1 , 5 , Ss(5) , 0)
   Call Nokia_text(1 , 6 , Ss(6) , 0)
   Call Nokia_text(1 , 7 , Ss(7) , 0)
   Call Nokia_text(1 , 8 , Ss(8) , 0)
  If S = "cls" Then                                         '   cls
   Call Nokia_clear()
    For I = 1 To 8
     Ss(i) = ""
    Next I
    I = 0
  End If
  Flagbuf = 0
 End If
Loop                                                        ' 
End

'*******************************************************************************
$include "Nokia-1100 Library.inc"                           ' 
'*******************************************************************************